local LibQTip = LibStub('LibQTip-1.0')

local pgfbroker = LibStub("AceAddon-3.0"):NewAddon("PGFinder.Broker", "AceEvent-3.0", "AceTimer-3.0")

pgfbrokerobj = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("PGFinder.Broker", {
	--type = "launcher",
	type = "data source",
	--text = "PGFinder.Broker",
	text = "Updating..",
	icon = "Interface\\GossipFrame\\PetitionGossipIcon.blp",
	OnClick = function(_, msg)
		if msg == "LeftButton" then
			if( IsControlKeyDown() ) then
				local name = UnitName("target");
				if name then
					ENABLED = false;
					ChatFrame1:AddMessage( "PGFinder ".."|cffeda55f" .. "Disabled".."|r to add new group." );
					C_LFGList.CreateListing(16,name,0,"","",true)
				end
			else
				if ( ENABLED ) then
					ENABLED = false;
					ChatFrame1:AddMessage( "PGFinder ".."|cffeda55f" .. "Disabled".."|r" );
				else
					ENABLED = true;
					ChatFrame1:AddMessage( "PGFinder ".."|cffeda55f" .. "Enabled".."|r" );
				end
			end
		elseif msg == "RightButton" then
			InterfaceOptionsFrame_OpenToCategory( optionsLists );
		end
		pgfbroker_updateText()
	end,
})

function pgfbrokerobj.OnEnter(self)
	local line
	pgfbroker_updateText()

	if LibQTip:IsAcquired("PGFinder.Broker") then
		tooltip:Clear()
	else
		tooltip = LibQTip:Acquire("PGFinder.Broker", 4)

		tooltip:SmartAnchorTo(self)

		tooltip:SetAutoHideDelay(0.1, self)
	end
	tooltip:AddLine("|cffffee00 PGFinder.Broker |r")
	tooltip:AddLine("|cffd6ff00 Click: |r Toggles |cffffee00PGFinder|r On or Off")
	tooltip:AddLine("|cff6cff00 Right-Click: |r Open |cffffee00PGFinder's|r Configuration Options")
	tooltip:AddLine("|cff6cff00 Ctrl-Click: |r Create |c00ff0000New|r LFG Group.")
	tooltip:AddSeparator()
	local tempK, tempV
	for tempK, tempV in pairs(PGF_profiles) do
		line = tooltip:AddLine(tempK)
		tooltip:SetLineScript(line, "OnMouseUp", pgfbroker_loadProfile, tempK)
	end
	tooltip:Show()
end

function pgfbrokerobj.OnLeave() end

function pgfbroker_loadProfile(info, profileID)
	loadProfile(profileID)
	pgfbroker_updateText()
end
function pgfbroker_updateText()
	local newtext
	local currentProfile = "Custom"
	local k, v
	local k2, v2
	local k3, v3
	local count=0
	local count2=0

	count = pgfbroker_keycount(keywords)
	for k,v in pairs(PGF_profiles) do
		local found = false
		--print(k)
		count2 = pgfbroker_keycount(PGF_profiles[k])
		if count2 == count then
			for k2,v2 in pairs(keywords) do
				for k3,v3 in pairs(PGF_profiles[k]) do
					if keywords[k2] == PGF_profiles[k][k3] then
						found = true
					end
				end
				if not found then
					break
				end
			end
			if count2 == 0 then
				found = true
			end
		end
		if found then
			currentProfile = k
		end
	end
	if ENABLED then
		newtext = "|cff6cff00  " .. currentProfile .. " |r"
	else
		newtext = "|cffff0000 " .. currentProfile .. " |r"
	end
	pgfbrokerobj.text = newtext
end
function pgfbroker_keycount(table_to_count)
	local keycount =0
	local k, v
	if type(table_to_count) == "table" then
		for k, v in pairs(table_to_count) do
			keycount = keycount+1
		end
	end
	return keycount
end

--function pgfbroker:LFG_LIST_SEARCH_RESULTS_RECEIVED(event)
--	pgfbroker_updateText()
--end

function pgfbroker:TimerFeedback()
	pgfbroker_updateText()
end

--pgfbroker:RegisterEvent("LFG_LIST_SEARCH_RESULTS_RECEIVED")
pgfbroker.selftimer = pgfbroker:ScheduleRepeatingTimer("TimerFeedback", 1)
pgfbroker_updateText()
